package sample;

import javafx.event.ActionEvent;
import javafx.fxml.FXML;
import javafx.scene.control.Button;
import javafx.scene.control.TextField;

public class Controller {
    @FXML
    private TextField textField;
    private String number1 = "";
    private String number2 = "";
    private String operator = "";


    @FXML
    void ProcessNumber(ActionEvent event) {
        if(operator.isEmpty()){
            String number = ((Button)event.getSource()).getText();
            number1 += number;
            textField.setText(textField.getText()+number);
        }else {
            String number = ((Button)event.getSource()).getText();
            number2 += number;
            textField.setText(textField.getText()+ number);
        }
    }

    @FXML
    void processOperator(ActionEvent event) {
        String temp = ((Button)event.getSource()).getText();

        if( temp.equals("Sin")){
            if(operator.isEmpty()){
                if(number1.isEmpty()){
                    return;
                }else {
                    number1 = String.valueOf(Math.sin(Double.parseDouble(number1)));
                    textField.setText(number1);
                }
            }else {
                if(number2.isEmpty()){
                    return;
                }else {
                    number2 = String.valueOf(Math.sin(Double.parseDouble(number2)));
                    textField.setText(number1+operator+number2);
                }
            }
            return;
        }

        if( temp.equals("Cos")){
            if(operator.isEmpty()){
                if(number1.isEmpty()){
                    return;
                }else {
                    number1 = String.valueOf(Math.cos(Double.parseDouble(number1)));
                    textField.setText(number1);
                }
            }else {
                if(number2.isEmpty()){
                    return;
                }else {
                    number2 = String.valueOf(Math.cos(Double.parseDouble(number2)));
                    textField.setText(number1+operator+number2);
                }
            }
            return;
        }
        if(number1.isEmpty()){
            return;
        }
        if(operator.isEmpty()){
            if(temp.equals("=")){
                return;
            }
            operator = temp;
            textField.setText(number1+operator);
        }else {
            if(number2.isEmpty()){
                return;
            }
            calculate();
            if(temp.equals("=")){
                operator = "";
                textField.setText(number1);
            }else {
                operator = temp;
                textField.setText(number1+operator);
            }
        }
    }

    public void calculate(){
        double n1 = Double.parseDouble(number1);
        double n2 = Double.parseDouble(number2);
        double result = 0;

        switch (operator){
            case "+":
                result = n1+n2;
                break;
            case "-":
                result = n1-n2;
                break;
            case "*":
                result = n1*n2;
                break;
            case "/":
                if(n2 == 0){
                    break;
                }
                result = n1/n2;
                break;
        }
        number1 = String.valueOf(result);
        number2 = "";
    }
    @FXML
    void allClear(ActionEvent event){
        number1 = "";
        number2 = "";
        operator = "";
        textField.setText("");
    }
}
